Index: /code/trunk/src/orxonox/core/CoreIncludes.h
===================================================================
--- /code/trunk/src/orxonox/core/CoreIncludes.h	(revision 870)
+++ /code/trunk/src/orxonox/core/CoreIncludes.h	(revision 871)
@@ -44,4 +44,5 @@
 // All needed header-files
 #include "Identifier.h"
+#include "ClassManager.h"
 #include "Factory.h"
 #include "ClassFactory.h"
@@ -51,4 +52,6 @@
 #include "Debug.h"
 
+
+// All needed macros
 /**
     @brief Intern macro, containing the common parts of RegisterObject and RegisterRootObject.
@@ -57,8 +60,8 @@
 */
 #define InternRegisterObject(ClassName, bRootClass) \
-    this->setIdentifier(orxonox::ClassIdentifier<ClassName>::registerClass(this->getParents(), #ClassName, bRootClass)); \
+    this->setIdentifier(orxonox::ClassManager<ClassName>::getIdentifier()->registerClass(this->getParents(), #ClassName, bRootClass)); \
     if (orxonox::Identifier::isCreatingHierarchy() && this->getParents()) \
-        this->getParents()->add(this->getIdentifier()); \
-    orxonox::ClassIdentifier<ClassName>::addObject(this)
+        this->getParents()->insert(this->getParents()->end(), this->getIdentifier()); \
+    orxonox::ClassManager<ClassName>::getIdentifier()->addObject(this)
 
 /**
@@ -68,5 +71,5 @@
 #define InternRegisterRootObject(ClassName) \
     if (orxonox::Identifier::isCreatingHierarchy() && !this->getParents()) \
-        this->setParents(new orxonox::IdentifierList()); \
+        this->createParents(); \
     InternRegisterObject(ClassName, true)
 
@@ -76,5 +79,5 @@
 */
 #define RegisterObject(ClassName) \
-    COUT(4) << "*** Register Object: " << #ClassName << std::endl; \
+    COUT(5) << "*** Register Object: " << #ClassName << std::endl; \
     InternRegisterObject(ClassName, false)
 
@@ -84,25 +87,6 @@
 */
 #define RegisterRootObject(ClassName) \
-    COUT(4) << "*** Register Root-Object: " << #ClassName << std::endl; \
+    COUT(5) << "*** Register Root-Object: " << #ClassName << std::endl; \
     InternRegisterRootObject(ClassName)
-
-/**
-    @brief Exports the necessary templates in order to make them available to all libraries.
-    @param ClassName The name of the Class
-    @param LibraryName The name of the Library
-*/
-#define ExportClass(ClassName, LibraryName) \
-    template class _##LibraryName##Export orxonox::ClassIdentifier<ClassName>; \
-    template class _##LibraryName##Export orxonox::ObjectList<ClassName>; \
-    template class _##LibraryName##Export orxonox::ClassFactory<ClassName>
-
-/**
-    @brief Exports the necessary templates in order to make them available to all libraries.
-    @param ClassName The name of the Class
-    @param LibraryName The name of the Library
-*/
-#define ExportAbstractClass(ClassName, LibraryName) \
-    template class _##LibraryName##Export orxonox::ClassIdentifier<ClassName>; \
-    template class _##LibraryName##Export orxonox::ObjectList<ClassName>
 
 /**
@@ -111,5 +95,5 @@
 */
 #define Class(ClassName) \
-    ClassIdentifier<ClassName>::getIdentifier()
+    ClassManager<ClassName>::getIdentifier()
 
 /**
@@ -137,7 +121,7 @@
     { \
         container##varname = new orxonox::ConfigValueContainer(this->getIdentifier()->getName(), #varname, varname = defvalue); \
-        this->getIdentifier()->setConfigValueContainer(#varname, container##varname); \
+        this->getIdentifier()->addConfigValueContainer(#varname, container##varname); \
     } \
-    container##varname->getValue(varname)
+    container##varname->getValue(&varname)
 
 /**
@@ -150,5 +134,5 @@
     { \
         container##varname##reset->resetConfigValue(); \
-        container##varname##reset->getValue(varname); \
+        container##varname##reset->getValue(&varname); \
     } \
     else \
Index: /code/trunk/src/orxonox/core/CorePrereqs.h
===================================================================
--- /code/trunk/src/orxonox/core/CorePrereqs.h	(revision 870)
+++ /code/trunk/src/orxonox/core/CorePrereqs.h	(revision 871)
@@ -27,10 +27,12 @@
 
 /**
- @file  OrxonoxPrereq.h
- @brief Contains all the necessary forward declarations for all classes, structs and enums.
- */
+    @file  CorePrereq.h
+    @brief Contains all the necessary forward declarations for all classes, structs and enums.
+*/
 
 #ifndef _CorePrereqs_H__
 #define _CorePrereqs_H__
+
+#include <string>
 
 #include "orxonox/OrxonoxPlatform.h"
@@ -63,4 +65,6 @@
 namespace orxonox
 {
+  typedef std::string LanguageEntryLabel;
+
   class ArgReader;
   class BaseFactory;
@@ -70,15 +74,21 @@
   template <class T>
   class ClassIdentifier;
+  template <class T>
+  class ClassManager;
+  class ClassTreeMask;
+  class ClassTreeMaskIterator;
+  class ClassTreeMaskNode;
   class ConfigValueContainer;
   class DebugLevel;
   class Error;
+  class Executor;
   class Factory;
   class Identifier;
-  class IdentifierList;
-  class IdentifierListElement;
+  class IdentifierDistributor;
   template <class T>
   class Iterator;
   class Language;
   class LanguageEntry;
+  class Level;
   class Loader;
   class MetaObjectList;
@@ -93,4 +103,10 @@
   template <class T>
   class SubclassIdentifier;
+  template <class T, class O>
+  class XMLPortClassObjectContainer;
+  template <class T>
+  class XMLPortClassParamContainer;
+  class XMLPortObjectContainer;
+  class XMLPortParamContainer;
 }
 
Index: /code/trunk/src/orxonox/core/Debug.h
===================================================================
--- /code/trunk/src/orxonox/core/Debug.h	(revision 870)
+++ /code/trunk/src/orxonox/core/Debug.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
  * @file Debug.h
  * @brief Handles the output for different verbose-modes.
@@ -55,5 +55,5 @@
 #define ORX_PRINT_DEBUG_OUTPUT 1 // <-- fix that! should be a configurable setting
 
-#define ORX_HARD_DEBUG_LEVEL ORX_DEBUG
+#define ORX_HARD_DEBUG_LEVEL ORX_vDEBUG
 //#define ORX_SOFT_DEBUG_LEVEL ORX_WARNING // <-- fix that! should be a configurable setting
 
Index: /code/trunk/src/orxonox/core/DebugLevel.cc
===================================================================
--- /code/trunk/src/orxonox/core/DebugLevel.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/DebugLevel.cc	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file DebugLevel.cc
     @brief Implementation of the DebugLevel class.
@@ -32,4 +32,5 @@
 
 #include "DebugLevel.h"
+#include "CoreIncludes.h"
 
 namespace orxonox
@@ -99,5 +100,6 @@
 
 /**
-    @returns the soft debug level, stored in the only existing instance of the DebugLevel class, configured in the config-file.
+    @brief Returns the soft debug level, stored in the only existing instance of the DebugLevel class, configured in the config-file.
+    @return The soft debug level
 */
 int getSoftDebugLevel()
Index: /code/trunk/src/orxonox/core/DebugLevel.h
===================================================================
--- /code/trunk/src/orxonox/core/DebugLevel.h	(revision 870)
+++ /code/trunk/src/orxonox/core/DebugLevel.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file DebugLevel.h
     @brief Definition of the DebugLevel class.
@@ -41,5 +41,4 @@
 #include "OrxonoxClass.h"
 #include "OutputHandler.h"
-#include "CoreIncludes.h"
 
 namespace orxonox
@@ -66,5 +65,4 @@
             ConfigValueContainer* softDebugLevelContainer_; //!< The config value container for the debug level
     };
-    ExportAbstractClass(DebugLevel, Core);
 }
 
Index: /code/trunk/src/orxonox/core/Error.cc
===================================================================
--- /code/trunk/src/orxonox/core/Error.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/Error.cc	(revision 871)
@@ -25,4 +25,9 @@
  *
  */
+
+/**
+    @file Error.cc
+    @brief Implementation of the Error class.
+*/
 
 #include "Debug.h"
Index: /code/trunk/src/orxonox/core/Error.h
===================================================================
--- /code/trunk/src/orxonox/core/Error.h	(revision 870)
+++ /code/trunk/src/orxonox/core/Error.h	(revision 871)
@@ -26,4 +26,9 @@
  */
 
+/**
+    @file Error.h
+    @brief Definition of the Error class.
+*/
+
 #ifndef _Error_H__
 #define _Error_H__
Index: /code/trunk/src/orxonox/core/Executor.cc
===================================================================
--- /code/trunk/src/orxonox/core/Executor.cc	(revision 871)
+++ /code/trunk/src/orxonox/core/Executor.cc	(revision 871)
@@ -0,0 +1,118 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ *   Inspiration: Executor by Benjamin Grauer
+ */
+
+#include "Executor.h"
+#include "Language.h"
+#include "util/String.h"
+
+namespace orxonox
+{
+    Executor::Executor(Functor* functor, const std::string& name)
+    {
+        this->functor_ = functor;
+        this->name_ = name;
+        this->bAddedDescription_ = false;
+        this->bAddedDescriptionReturnvalue_ = false;
+        this->bAddedDescriptionParam_[0] = false;
+        this->bAddedDescriptionParam_[1] = false;
+        this->bAddedDescriptionParam_[2] = false;
+        this->bAddedDescriptionParam_[3] = false;
+        this->bAddedDescriptionParam_[4] = false;
+    }
+
+    Executor::~Executor()
+    {
+    }
+
+    void Executor::setName(const std::string name)
+    {
+        this->name_ = name;
+    }
+
+    const std::string& Executor::getName() const
+    {
+        return this->name_;
+    }
+
+    void Executor::description(const std::string& description)
+    {
+        if (!this->bAddedDescription_)
+        {
+            this->description_ = std::string("ExecutorDescription::" + this->name_ + "::function");
+            AddLanguageEntry(this->description_, description);
+            this->bAddedDescription_ = true;
+        }
+    }
+
+    const std::string& Executor::getDescription() const
+    {
+        return GetLocalisation(this->description_);
+    }
+
+    void Executor::descriptionParam(int param, const std::string& description)
+    {
+        if (param > 0 && param <= 5)
+        {
+            if (!this->bAddedDescriptionParam_[param])
+            {
+                std::string paramnumber;
+                if (!Convert::ToString(&paramnumber, param))
+                    return;
+
+                this->descriptionParam_[param] = std::string("ExecutorDescription::" + this->name_ + "::param" + paramnumber);
+                AddLanguageEntry(this->descriptionParam_[param], description);
+                this->bAddedDescriptionParam_[param] = true;
+            }
+        }
+    }
+
+    const std::string& Executor::getDescriptionParam(int param) const
+    {
+        if (param > 0 && param <= 5)
+        {
+            return GetLocalisation(this->descriptionParam_[param]);
+        }
+
+        return this->descriptionParam_[0];
+    }
+
+    void Executor::descriptionReturnvalue(const std::string& description)
+    {
+        if (!this->bAddedDescriptionReturnvalue_)
+        {
+            this->descriptionReturnvalue_ = std::string("ExecutorDescription::" + this->name_ + "::returnvalue");
+            AddLanguageEntry(this->descriptionReturnvalue_, description);
+            this->bAddedDescriptionReturnvalue_ = true;
+        }
+    }
+
+    const std::string& Executor::getDescriptionReturnvalue(int param) const
+    {
+        return GetLocalisation(this->descriptionReturnvalue_);
+    }
+}
Index: /code/trunk/src/orxonox/core/Executor.h
===================================================================
--- /code/trunk/src/orxonox/core/Executor.h	(revision 871)
+++ /code/trunk/src/orxonox/core/Executor.h	(revision 871)
@@ -0,0 +1,117 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ *   Inspiration: Executor by Benjamin Grauer
+ */
+
+#ifndef _Executor_H__
+#define _Executor_H__
+
+#include "CorePrereqs.h"
+#include "Functor.h"
+
+namespace orxonox
+{
+    class _CoreExport Executor
+    {
+        public:
+            Executor(Functor* functor, const std::string& name = "");
+            virtual ~Executor();
+
+            inline virtual void operator()(const MultiTypeMath& param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+                { (*this->functor_)(param1, param2, param3, param4, param5); }
+
+            void setName(const std::string name);
+            const std::string& getName() const;
+
+            void description(const std::string& description);
+            const std::string& getDescription() const;
+
+            void descriptionParam(int param, const std::string& description);
+            const std::string& getDescriptionParam(int param) const;
+
+            void descriptionReturnvalue(const std::string& description);
+            const std::string& getDescriptionReturnvalue(int param) const;
+
+            inline int getParamCount() const
+                { return this->functor_->getParamCount(); }
+            inline bool hasReturnvalue() const
+                { return this->functor_->hasReturnvalue(); }
+            inline FunctionType getType() const
+                { return this->functor_->getType(); }
+            inline MultiTypeMath getReturnvalue() const
+                { return this->functor_->getReturnvalue(); }
+            inline std::string getTypenameParam(int param) const
+                { return this->functor_->getTypenameParam(param); }
+            inline std::string getTypenameReturnvalue() const
+                { return this->functor_->getTypenameReturnvalue(); }
+
+        protected:
+            Functor* functor_;
+
+        private:
+            std::string name_;
+
+            LanguageEntryLabel description_;
+            LanguageEntryLabel descriptionReturnvalue_;
+            LanguageEntryLabel descriptionParam_[5];
+
+            bool bAddedDescription_;
+            bool bAddedDescriptionReturnvalue_;
+            bool bAddedDescriptionParam_[5];
+    };
+
+    class _CoreExport ExecutorStatic : public Executor
+    {
+        public:
+            ExecutorStatic(FunctorStatic* functor, const std::string& name = "") : Executor(functor, name) {}
+            virtual ~ExecutorStatic() {}
+
+            inline virtual void operator()(const MultiTypeMath& param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+                { (*this->functor_)(param1, param2, param3, param4, param5); }
+    };
+
+    template <class T>
+    class ExecutorMember : public Executor
+    {
+        public:
+            ExecutorMember(FunctorMember<T>* functor, const std::string& name = "") : Executor(functor, name) {}
+            virtual ~ExecutorMember() {}
+
+            inline virtual void operator()(T* object, const MultiTypeMath& param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+                { (*this->functor_)(object, param1, param2, param3, param4, param5); }
+            inline virtual void operator()(const T* object, const MultiTypeMath param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+                { (*this->functor_)(object, param1, param2, param3, param4, param5); }
+            inline virtual void operator()(const MultiTypeMath& param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+                { (*this->functor_)(param1, param2, param3, param4, param5); }
+
+            inline void setObject(T* object)
+                { this->functor_->setObject(object); }
+            inline void setObject(const T* object)
+                { this->functor_->setObject(object); }
+    };
+}
+
+#endif /* _Executor_H__ */
Index: /code/trunk/src/orxonox/core/Factory.cc
===================================================================
--- /code/trunk/src/orxonox/core/Factory.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/Factory.cc	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file Factory.cc
     @brief Implementation of the Factory class.
@@ -39,6 +39,7 @@
 {
     /**
-        @returns the Identifier with a given name.
+        @brief Returns the Identifier with a given name.
         @param name The name of the wanted Identifier
+        @return The Identifier
     */
     Identifier* Factory::getIdentifier(const std::string& name)
@@ -48,6 +49,7 @@
 
     /**
-        @returns the Identifier with a given network ID.
+        @brief Returns the Identifier with a given network ID.
         @param id The network ID of the wanted Identifier
+        @return The Identifier
     */
     Identifier* Factory::getIdentifier(const unsigned int id)
@@ -84,5 +86,5 @@
     void Factory::createClassHierarchy()
     {
-        COUT(3) << "*** Factory -> Create class-hierarchy" << std::endl;
+        COUT(3) << "*** Factory: Create class-hierarchy" << std::endl;
         std::map<std::string, Identifier*>::iterator it;
         it = getFactoryPointer()->identifierStringMap_.begin();
@@ -95,5 +97,5 @@
         }
         (*getFactoryPointer()->identifierStringMap_.begin()).second->stopCreatingHierarchy();
-        COUT(3) << "*** Factory -> Finished class-hierarchy creation" << std::endl;
+        COUT(3) << "*** Factory: Finished class-hierarchy creation" << std::endl;
     }
 
@@ -107,3 +109,21 @@
       return &theOneAndOnlyFactoryInstance;
     }
+
+    /**
+        @brief Returns the begin-iterator of the factory-map.
+        @return The begin-iterator
+    */
+    std::map<std::string, Identifier*>::const_iterator Factory::getFactoryBegin()
+    {
+        return Factory::getFactoryPointer()->identifierStringMap_.begin();
+    }
+
+    /**
+        @brief Returns the end-iterator of the factory-map.
+        @return The end-iterator
+    */
+    std::map<std::string, Identifier*>::const_iterator Factory::getFactoryEnd()
+    {
+        return Factory::getFactoryPointer()->identifierStringMap_.end();
+    }
 }
Index: /code/trunk/src/orxonox/core/Factory.h
===================================================================
--- /code/trunk/src/orxonox/core/Factory.h	(revision 870)
+++ /code/trunk/src/orxonox/core/Factory.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file Factory.h
     @brief Definition of the Factory and the BaseFactory class.
@@ -67,4 +67,6 @@
 
             static Factory* getFactoryPointer();    // avoid overriding order problem in the static intialisation process
+            static std::map<std::string, Identifier*>::const_iterator getFactoryBegin();
+            static std::map<std::string, Identifier*>::const_iterator getFactoryEnd();
 
         private:
